import yoda, sys
from math import sqrt

fName = str(sys.argv[1]) if len(sys.argv) > 1 else ''

if not fName:
  sys.exit('Need to specify file name!')

hists = yoda.read(fName)
f = open('%s_reprocessed.yoda' % fName[:-5], 'w')
for name in hists:
  if 'd01-x02' in name:  continue
  if 'd01-x01' in name:
    ratio = name.replace('x01', 'x02')
    hasWeights = hists[name].effNumEntries != hists[name].numEntries
    for i in range(hists[ratio].numPoints):
      n = hists[name].bins[i+1].sumW
      d = hists[name].bins[i].sumW
      r = n/d
      dN = hists[name].bins[i+1].sumW2
      dD = hists[name].bins[i].sumW2
      e = sqrt(r * (1 - r) / d) if d else 0.0
      if hasWeights:
        e =  sqrt( ((1 - 2 * r) * dN + r ** 2 * dD) / d ** 2 ) if d else 0.0
      hists[ratio].points[i].y = r
      hists[ratio].points[i].yErrs = (e, e)
    yoda.writeYODA(hists[ratio], f)
  yoda.writeYODA(hists[name], f)
f.close()

